require 'yaml'
NETATLAS_CONFIG_DIR = ENV['NETATLAS_CONFIG_DIR'] || "/etc/netatlas"
NETATLAS_ENVIRONMENT = ENV['NETATLAS_ENVIRONMENT'] || "development"
CONFIG = YAML.load(File.open(NETATLAS_CONFIG_DIR + "/netatlas.yml"))[NETATLAS_ENVIRONMENT]
NETATLAS_LOG_DIR = ENV['NETATLAS_LOG_DIR'] || ENV['HOME'] + "/.log"

puts CONFIG.inspect

$:.unshift File.dirname(__FILE__) + "/../lib"

require 'eventmachine'
require 'em/queue'
require 'mq'
require 'netatlas/resource/base'
require 'netatlas/resource/data_source'
require 'netatlas/result'

require 'netatlas/plugin/base'
require 'netatlas/plugin/nagios'
require 'netatlas/plugin/http'
require 'netatlas/plugin/snmp'
