module NetAtlas
  module Plugin
    class HTTP < Nagios

      def self.check_script
        "check_http"
      end

      plugin_arguments do
        port 80
        use_ipv4 true
        use_ipv6 false
        ssl false
        certificate Integer
        expect String
        string String
        url String
        post String
        method = ['HEAD', 'GET', 'POST', 'PUT', 'TRACE', 'OPTIONS', 'DELETE']
        no_body false
        max_age Integer
        content_type String
        linespan false
        regex String
        erigi String
        invert_regex false
        authorization String
        useragent String
        header String
        onredirect ['ok', 'warning', 'critical', 'follow', 'sticky', 'stickyport']
        pagesize String
      end

    end
  end
end